import _ from "lodash";
// import jszip from "jszip";
// import Solution from "./models/solution";

export default {
    state: {
        pregraftData: null,
        linkAvailable: false
    },
    getters: {
        getPregraftData(state) {
            return state.pregraftData;
        },
        getGraftingStateLink(state, getters) {
            return state.linkAvailable ? getters.getApi.defaults.baseURL +  getters.getApi.getUri({url: `/graftstatus`}) : null
        } 
    },
    mutations: {
        setPregraftData(state, data) {
            state.pregraftData = data;
        },
        setLinkAvailable(state, available) {
            state.linkAvailable = available;
        },
        removeGrafts(state) {
            state.grafts = [];
        }
    },
    actions: {

        pregraft(context){
            let request = context.getters.getApi.post("/pregraft", {
                scaffold: {
                    pdb: context.getters.getScaffold.name,
                    chain: context.getters.getScaffold.chain
                },
                insert: {
                    pdb: context.getters.getInsert.name,
                    chain: context.getters.getInsert.chain,
                },
                loop_pairing: context.getters.getWantedLoops.map(l => (
                    {
                        candidate: {
                            name: l.id,
                            ss1_start: l.start,
                            ss1_end: l.coilStart,
                            ss2_start: l.coilEnd,
                            ss2_end: l.end
                        },
                        replacement: {
                            name: l.replacement.id,
                            ss1_start: l.replacement.start,
                            ss1_end: l.replacement.coilStart,
                            ss2_start: l.replacement.coilEnd,
                            ss2_end: l.replacement.end

                        }
                    }
                ))
            }).then((response) => {
                context.commit("setPregraftData", {
                    sequences: Object.values(response.data.sequences),
                });
            });
            context.dispatch("addAwaitable", {
                id: _.uniqueId("awaiting"),
                promise: request,
                description: `Pregrafting...`
            });
        },
        startGrafting(context, { rosseta, modeller }) {
            let request = context.getters.getApi.post("/graft", {
                licences: {
                    rosseta: rosseta,
                    modeller: modeller
                },
                scaffold: {
                    pdb: context.getters.getScaffold.name,
                    chain: context.getters.getScaffold.chain
                },
                insert: {
                    pdb: context.getters.getInsert.name,
                    chain: context.getters.getInsert.chain,
                },
                loop_pairing: context.getters.getWantedLoops.map(l => (
                    {
                        candidate: {
                            name: l.id,
                            ss1_start: l.start,
                            ss1_end: l.coilStart,
                            ss2_start: l.coilEnd,
                            ss2_end: l.end
                        },
                        replacement: {
                            name: l.replacement.id,
                            ss1_start: l.replacement.start,
                            ss1_end: l.replacement.coilStart,
                            ss2_start: l.replacement.coilEnd,
                            ss2_end: l.replacement.end

                        }
                    }
                ))
            }).then(() => {
                context.commit("setLinkAvailable", true);
            });
            context.dispatch("addAwaitable", {
                id: _.uniqueId("awaiting"),
                promise: request,
                description: `Grafting...`
            });
        },


    }
}